<script type="text/javascript" src="https://maps.google.com/maps/api/js?sensor=false"></script>
<script type="text/javascript" src="js/eventsMap_markerclusterer_compiled.js"></script>

<!-- Events load data javascript-->
<script type="text/javascript">
//<![CDATA[
    var infoWindow;
	var gedcomArray = new Array();
	var gedNameArray = new Array();
	var yearFromArray = new Array();
	var yearToArray = new Array();
	var eventsArray = new Array();
	var eventsArrayCustom = new Array();
	var placeArray = new Array();
	
	
	var markerClusterer = null;
	var map = null;
	var markers = null;
	var trees = null;
	// the five filters from menu, initialized as true
	var menuFiltersArray = new Array(true,true,true,true,true,true);
	// *** STATISTICS
	var totalEventsFound = 0;
	var totalPlacesFound = 0;
	var eventsStatisticsBool = false;
	var totalBirths = 0;
	var totalBaptisms = 0;
	var totalMarriages = 0;
	var totalDeaths = 0;
	var totalBurials = 0;
	var totalOther = 0;
	
	// adicionado por Heuser para mensagens de texto por lingua
	var textMessages = new Array();
    textMessages['mapOptions'] = "<?php echo $text['em_mapOptions']; ?>";
    textMessages['birth'] = "<?php echo $text['em_births']; ?>";		
    textMessages['christened'] = "<?php echo $text['em_christenings']; ?>";		
    textMessages['died'] = "<?php echo $text['em_deaths']; ?>";		
    textMessages['buried'] = "<?php echo $text['em_burials']; ?>";		
    textMessages['otherEvent'] = "<?php echo $text['em_other']; ?>";		
    textMessages['married'] = "<?php echo $text['em_marriages']; ?>";		
    textMessages['eventType'] = "<?php echo $text['em_eventType']; ?>";		
    textMessages['dateRange'] = "<?php echo $text['em_dateRange']; ?>";
    textMessages['showStatistics'] = "<?php echo $text['em_showStatistics']; ?>";
    textMessages['clearMap'] = "<?php echo $text['em_clear']; ?>";
    textMessages['totalEvents'] = "<?php echo $text['em_totalEvents']; ?>";	
    textMessages['totalPlaces'] = "<?php echo $text['em_totalPlaces']; ?>";
    textMessages['gedcom'] = "<?php echo $text['gedcom']; ?>";	
    textMessages['place'] = "<?php echo $text['place']; ?>";	
    textMessages['latitude'] = "<?php echo $text['latitude']; ?>";	
    textMessages['longitude'] = "<?php echo $text['longitude']; ?>";	
    
    
    var tngConfigPlaces1Tree = "<?php echo $tngconfig['places1tree'] ?>";	
//    var tngMapConfigDispltype = "<?php echo $map['displaytype'] ?>";
    var gedcomSelected;
    var eventHandling;
    
    eventsArray = [];
    
    

<?php

include("eventsMap_config.php");	

print "gedcomSelected = '" . cDefaultTree . "';"; // comes from config file
print "eventHandling = '" . cEventHandling . "';"; // comes from config file

$resultPlaces = "";
$queryPlacesStringBuild = "";


include("eventsMap_queryTrees.php");				// Fills $resultTrees (SELECT gedcom, treename)
	// write javascript to fill Gedcom (written on JS code, in the first run)
print "gedcomArray.push('" . "------" . "');"; //heuser - first array position - no gedcom selected
print "gedNameArray.push('" . "----------" . "');"; //heuser - first array position - no gedcom selected
while ($tree = mysql_fetch_assoc($resultTrees)) {
		print "gedcomArray.push('" . $tree['gedcom'] . "');";
		print "gedNameArray.push('" . $tree['treename'] . "');";
}
	// write javascript to fill all the possible search dates.
print "yearFromArray.push('" . "----" . "');"; //heuser - year from sem limite
$auxToPopulateDates = cFromDataMenu;
while ($auxToPopulateDates <= cToDataMenu) {
	print "yearFromArray.push('" . $auxToPopulateDates . "');";
	print "yearToArray.push('" . $auxToPopulateDates . "');";
	$auxToPopulateDates += cIncrementDataMenu;
}
print "yearToArray.push('" . "----"  . "');";//heuser - year to sem limite
	
include("eventsMap_queryBuilder.php"); 			// FIRST TIME - Fills $resultPlaces (SELECT place, latitude, longitude) with all places

while ($place = mysql_fetch_assoc($resultPlaces)) {
	print "eventsArray.push({" .
		"id : '" . $place['ID'] . "' ," .
		"gedcom : '" . $place['gedcom'] . "' ," .
//		"place : replaceAll('&amp;', '\&', " . 
//		  "replaceAll('&apos;', '\'', '" . 
//			str_replace("'", '&apos;', str_replace('&', '&amp;', $place['place'])) . "')) ," .
		"place : '" . str_replace("'", '&apos;', str_replace('&', '&amp;', $place['place'])) . "' ," .
		"lat : '" . $place['latitude'] . "' ," .
		"lon : '" . $place['longitude'] . "' ," .
		"year : '" . $place['year'] . "' ," .
		"event : '" . $place['event'] . "' });
		";
		
//	}
}

include("js/eventsMap_CustomControllers.js");		// Create the custom controllers.

?>

function createOneMarker(lat, lon, place, gedcom) {
	
	var placeTitle = replaceAll('&amp;', '\&', 
						replaceAll('&apos;', '\'', place));
						 
	var gedcomMsgUrl = "";
	if (tngConfigPlaces1Tree ==  '0') gedcomMsgUrl = '&tree=' + gedcom;
	var gedcomMsgTitle = "";
	if (tngConfigPlaces1Tree ==  '0') gedcomMsgTitle = '\x0A' + textMessages['gedcom'] + ': ' + gedcom;
	
	latLng = new google.maps.LatLng(lat, lon);  // create a latlng with this location
	var marker = new google.maps.Marker({ 		// create a marker for this location
	position: latLng,
	url:'placesearch.php?psearch=' + encodeURIComponent(placeTitle) +  gedcomMsgUrl,
	title:textMessages['place'] + ': ' + placeTitle + '\x0A' + 
		textMessages['latitude'] + ': ' + lat + '\x0A' +
		textMessages['longitude'] + ': ' + lon + gedcomMsgTitle
	});
					
	//when a place is clicked at, the system goes to this place's page on TNG
	google.maps.event.addListener(marker, 'click',
	function() {
		window.open(this.url, '_blank').focus();
	});
						
	markers.push(marker);
	counterTotalPlaces++; 
}
		
function replaceAll(find, replace, str) {
  return str.replace(new RegExp(find, 'g'), replace);
}

function compareLatLong(a,b) {
	var aLatNumber = parseFloat(a.lat);
	var bLatNumber = parseFloat(b.lat);
	var aLonNumber = parseFloat(a.lon);
	var bLonNumber = parseFloat(b.lon);
	
	if (aLatNumber < bLatNumber) {return -1}
	else if (aLatNumber > bLatNumber) {return 1}
		 else if (aLonNumber < bLonNumber) {return -1}
			  else if (aLonNumber > bLonNumber) {return 1}
		  		   else return 0;
}

function incrementLatOrLon (latOrLon, incrValue) {
    var newValue = parseFloat(latOrLon) + incrValue
	return newValue.toString();
}

function UpdateCluster(menuFiltersArray, map, gedcomSelected, dateFromSelected, dateToSelected, statisticsTrueFalse) {

	
	eventsArrayCustom.length = 0;
	placeArray.length = 0;
			
    if (markerClusterer) {
      markerClusterer.clearMarkers();
    }
	markers = [];
	counterTotalPlaces = 0;
	totalBirths = 0;
	totalBaptisms = 0;
	totalMarriages = 0;
	totalDeaths = 0;
	totalBurials = 0;
	totalOther = 0;
	
	// creates the array eventsArrayCustom containing just the events to be displayed by applying filters
	if (eventHandling == "1") {// consider events
		for (var n = 0; n < eventsArray.length; n++) { 							
				if ((gedcomSelected == "------" || eventsArray[n].gedcom == gedcomSelected) &&
				    (menuFiltersArray[eventsArray[n].event] == true) &&	// test the gedcomSelected and if the event is selected (true)
					(dateFromSelected == "----" || eventsArray[n].year >= dateFromSelected) && // test the date range
				    (dateToSelected == "----" || eventsArray[n].year <= dateToSelected)) {
					    eventsArrayCustom.push(eventsArray[n]);					
						switch(eventsArray[n].event){
							case "0":
								totalBirths++
								break
							case "1":
								totalBaptisms++
								break
							case "2":
								totalMarriages++
								break
							case "3":
								totalDeaths++
								break
							case "4":
								totalBurials++
								break
							case "5":
								totalOther++
								break
						}
					}
		}// end for
	} else {// just places
		for (var n = 0; n < eventsArray.length; n++) { 	// filter by gedcom						
				if ((gedcomSelected == "------" || eventsArray[n].gedcom == gedcomSelected)) {
					    eventsArrayCustom.push(eventsArray[n]);					
					}
		}// end for
	}


	//extracts places from the array
	for (var n = 0; n < eventsArrayCustom.length; n++) { 						
		if (n == 0) {//first position - just copy place
			placeArray.push(
				{gedcom : eventsArrayCustom[n].gedcom,
				 place : eventsArrayCustom[n].place, 
				 lat :  eventsArrayCustom[n].lat,
				 lon :  eventsArrayCustom[n].lon,
				});
		} else { //from second position up - compare with previous to see if different place
				if (eventsArrayCustom[n].id != eventsArrayCustom[n-1].id ) {
							placeArray.push(
								{gedcom : eventsArrayCustom[n].gedcom,
								 place : eventsArrayCustom[n].place, 
								 lat :  eventsArrayCustom[n].lat,
								 lon :  eventsArrayCustom[n].lon,
								});
				}
		}		
	}

	
		
	//sorts places by latitude, longitude
	placeArray.sort(compareLatLong);
	
	
	
	
	//creates Google maps markers
	for (var n = 0; n < placeArray.length; n++) { 
		createOneMarker(placeArray[n].lat, placeArray[n].lon, placeArray[n].place, placeArray[n].gedcom)						

        // creates markers for elements that follow and are at the same location
        var sameCoordCount = 0;
        if (n < (placeArray.length-1)) {
	        for (var ni = (n + 1); ni < placeArray.length; ni++ ) { 
	        	if (Math.abs(parseFloat(placeArray[n].lat)-parseFloat(placeArray[ni].lat)) < 0.00004  && 
		            Math.abs(parseFloat(placeArray[n].lon)-parseFloat(placeArray[ni].lon)) < 0.00004 )
		            {sameCoordCount++; 
		             createOneMarker(incrementLatOrLon(placeArray[n].lat,0.00004*(ni-n)), incrementLatOrLon(placeArray[n].lon,0.00004*(ni-n)), placeArray[ni].place, placeArray[ni].gedcom)
		             } else {break}           
		        }
		      }

		n = n + sameCoordCount;
		
	}

	if (document.getElementById('ScrollItem1')) updateStatistics(eventsArrayCustom.length,counterTotalPlaces,eventsStatisticsBool, totalBirths, totalBaptisms, totalMarriages, totalDeaths, totalBurials, totalOther);
						
	// updates the cluster with array of markers
	markerCluster = new MarkerClusterer(map, markers);
	
	// CLUSTER CLICK FOR THE LAST ZOOM LEVEL -> GENERATES AN INFO WINDOW (this should not happen as the places were shifted)
	google.maps.event.addListener(markerCluster,'clusterclick',
	function(clickedCluster){
		// If zoom is maxed out already
		if (map.getZoom() == 21){
		infoWindow = new google.maps.InfoWindow();
		infoWindow.setContent("This tree contains multiple Places defined on this exact same Geoposition: " + clickedCluster.getCenter());
		infoWindow.setPosition(clickedCluster.getCenter());
		infoWindow.open(map);
		}
	});
	
	
	return markerCluster;
}// end updateCluster

	
	
	
function init() {
    var latLng = new google.maps.LatLng(<?php echo mapLatInit; ?>, <?php echo mapLngInit; ?>);
    var myOptions = {
        zoom : <?php echo mapZoomInit; ?>,
        center : latLng,
        mapTypeId : google.maps.MapTypeId.ROADMAP
        };
    map = new google.maps.Map(document.getElementById("wmMap"), myOptions);
	


	markerClusterer = UpdateCluster(menuFiltersArray, map, gedcomSelected, "----", "----", false)
	
    // Create the DIV to hold the control and call the CustomControllers() constructor
    // passing in this DIV.
    if (tngConfigPlaces1Tree != "1" || eventHandling != "0") {
	    var CustomControlDiv = document.createElement('DIV');
	    var customControllers = new CustomControllers(CustomControlDiv, map, gedcomArray, gedNameArray, yearFromArray, yearToArray, gedcomSelected); // heuser adicionado gedcomSelected
	    CustomControlDiv.index = 1;
	    map.controls[google.maps.ControlPosition.RIGHT_TOP].push(CustomControlDiv);
	 }
							
			
} // end initialize
	
// *** STATISTICS
function updateStatistics(totalEvents, totalPlaces, eventsStatisticsBool, totalBirths, totalBaptisms, totalMarriages, totalDeaths, totalBurials, totalOther){
	if (tngConfigPlaces1Tree != "1" || eventHandling != "0") {
		if (eventHandling == "1") {	//statistics are schown when events are handled	
			if (eventsStatisticsBool){
				document.getElementById('DivTotalEvents').innerHTML = textMessages['totalEvents'] + totalEvents;
				document.getElementById('DivTotalPlaces').innerHTML = textMessages['totalPlaces'] + totalPlaces;
				document.getElementById('ScrollItem1').innerHTML = '<a href="#" title=""><img src="img/eventsMap_tng_cal_birth.png" alt="" />&nbsp;'+textMessages['birth']+' ('+totalBirths+')</a>';
				document.getElementById('ScrollItem2').innerHTML = '<a href="#" title=""><img src="img/eventsMap_tng_cal_bapt.png" alt="" />&nbsp;'+textMessages['christened']+' ('+totalBaptisms+')</a>';
				document.getElementById('ScrollItem3').innerHTML = '<a href="#" title=""><img src="img/eventsMap_tng_cal_marr.png" alt="" />&nbsp;'+textMessages['married']+' ('+totalMarriages+')</a>';
				document.getElementById('ScrollItem4').innerHTML = '<a href="#" title=""><img src="img/eventsMap_tng_cal_death.png" alt="" />&nbsp;'+textMessages['died']+' ('+totalDeaths+')</a>';
				document.getElementById('ScrollItem5').innerHTML = '<a href="#" title=""><img src="img/eventsMap_tng_cal_burial.png" alt="" />&nbsp;'+textMessages['buried']+' ('+totalBurials+')</a>';
				document.getElementById('ScrollItem6').innerHTML = '<a href="#" title="">&omicron;&nbsp;&nbsp;'+textMessages['otherEvent']+' ('+totalOther+')</a>';
			}else{
				document.getElementById('ScrollItem1').innerHTML = '<a href="#" title=""><img src="img/eventsMap_tng_cal_birth.png" alt="" />&nbsp;'+textMessages['birth']+'</a>';
				document.getElementById('ScrollItem2').innerHTML = '<a href="#" title=""><img src="img/eventsMap_tng_cal_bapt.png" alt="" />&nbsp;'+textMessages['christened']+'</a>';
				document.getElementById('ScrollItem3').innerHTML = '<a href="#" title=""><img src="img/eventsMap_tng_cal_marr.png" alt="" />&nbsp;'+textMessages['married']+'</a>';
				document.getElementById('ScrollItem4').innerHTML = '<a href="#" title=""><img src="img/eventsMap_tng_cal_death.png" alt="" />&nbsp;'+textMessages['died']+'</a>';
				document.getElementById('ScrollItem5').innerHTML = '<a href="#" title=""><img src="img/eventsMap_tng_cal_burial.png" alt="" />&nbsp;'+textMessages['buried']+'</a>';
				document.getElementById('ScrollItem6').innerHTML = '<a href="#" title="">&omicron;&nbsp;&nbsp;'+textMessages['otherEvent']+'</a>';
			}
		}	
	}	
}
	
	google.maps.event.addDomListener(window, 'load', init);

//]]>	
</script>
<div id="wmMap" />