<?php
//queryBuilder.php

if (cEventHandling == "1") {//events are handled
	if ($tngconfig['places1tree'] == "0") { //places are attached to gedcoms
		$queryPlaces = "
			SELECT DISTINCT TPL.ID, TPL.gedcom, TPL.place, TPL.latitude, TPL.longitude, year, event
			 FROM (
				SELECT DISTINCT gedcom, birthplace AS place, SUBSTR(birthdatetr,1,4) as year, 0 as event
				FROM  `$people_table` 
				UNION ALL
				SELECT DISTINCT gedcom, deathplace AS place, SUBSTR(deathdatetr,1,4) as year, 3 as event
				FROM  `$people_table` 
				UNION ALL
				SELECT DISTINCT gedcom, burialplace AS place, SUBSTR(burialdatetr,1,4) as year, 4 as event
				FROM  `$people_table` 
				UNION ALL
				SELECT DISTINCT gedcom, altbirthplace AS place, SUBSTR(altbirthdatetr,1,4) as year, 1 as event
				FROM  `$people_table` 
				UNION ALL
				SELECT DISTINCT gedcom, marrplace AS place, SUBSTR(marrdatetr,1,4) as year, 2 as event
				FROM  `$families_table`
				UNION ALL
				SELECT DISTINCT gedcom, baptplace AS place, SUBSTR(baptdatetr,1,4) as year, 5 as event
				FROM  `$people_table`
				UNION ALL
				SELECT DISTINCT gedcom, confplace AS place, SUBSTR(confdatetr,1,4) as year, 5 as event
				FROM  `$people_table`
				UNION ALL
				SELECT DISTINCT gedcom, initplace AS place, SUBSTR(initdatetr,1,4) as year, 5 as event
				FROM  `$people_table`
				UNION ALL
				SELECT DISTINCT gedcom, endlplace AS place, SUBSTR(endldatetr,1,4) as year, 5 as event
				FROM  `$people_table`
				UNION ALL
				SELECT DISTINCT gedcom, eventplace AS place, SUBSTR(eventdatetr,1,4) as year, 5 as event
				FROM  `$events_table`
				UNION ALL
				SELECT DISTINCT gedcom, divplace AS place, SUBSTR(divdatetr,1,4) as year, 2 as event
				FROM  `$families_table`
			) AS TPE,
			 `$places_table` AS TPL
			WHERE TPL.gedcom = TPE.gedcom
			AND TPE.place = TPL.place
			AND latitude IS NOT NULL AND latitude <> ''
			ORDER BY ID
		";
	} else { // places are not attached to gedcoms
		$queryPlaces = "
		     SELECT DISTINCT TPL.ID, TPE.gedcom, TPL.place, TPL.latitude, TPL.longitude, year, event
			 FROM (
				SELECT DISTINCT gedcom, birthplace AS place, SUBSTR(birthdatetr,1,4) as year, 0 as event
				FROM  `$people_table` 
				UNION ALL
				SELECT DISTINCT gedcom, deathplace AS place, SUBSTR(deathdatetr,1,4) as year, 3 as event
				FROM  `$people_table` 
				UNION ALL
				SELECT DISTINCT gedcom, burialplace AS place, SUBSTR(burialdatetr,1,4) as year, 4 as event
				FROM  `$people_table` 
				UNION ALL
				SELECT DISTINCT gedcom, altbirthplace AS place, SUBSTR(altbirthdatetr,1,4) as year, 1 as event
				FROM  `$people_table` 
				UNION ALL
				SELECT DISTINCT gedcom, marrplace AS place, SUBSTR(marrdatetr,1,4) as year, 2 as event
				FROM  `$families_table`
				UNION ALL
				SELECT DISTINCT gedcom, baptplace AS place, SUBSTR(baptdatetr,1,4) as year, 5 as event
				FROM  `$people_table`
				UNION ALL
				SELECT DISTINCT gedcom, confplace AS place, SUBSTR(confdatetr,1,4) as year, 5 as event
				FROM  `$people_table`
				UNION ALL
				SELECT DISTINCT gedcom, initplace AS place, SUBSTR(initdatetr,1,4) as year, 5 as event
				FROM  `$people_table`
				UNION ALL
				SELECT DISTINCT gedcom, endlplace AS place, SUBSTR(endldatetr,1,4) as year, 5 as event
				FROM  `$people_table`
				UNION ALL
				SELECT DISTINCT gedcom, eventplace AS place, SUBSTR(eventdatetr,1,4) as year, 5 as event
				FROM  `$events_table`
				UNION ALL
				SELECT DISTINCT gedcom, divplace AS place, SUBSTR(divdatetr,1,4) as year, 2 as event
				FROM  `$families_table`
			) AS TPE,
			 `$places_table` AS TPL
			WHERE  TPE.place = TPL.place
			AND latitude IS NOT NULL AND latitude <> ''
			ORDER BY ID
		";
	}
} else {//just places are displayed
		$queryPlaces = "
			SELECT DISTINCT ID, gedcom, place, latitude, longitude, '0000', '0'
			FROM `$places_table`
			WHERE latitude <> ''
		";
}
$resultPlaces = mysql_query($queryPlaces);
if (false === $resultPlaces) {
      echo mysql_error();
  };

$resultPlacesNum = mysql_num_rows($resultPlaces);

?>