    function CustomControllers(controlDiv, map, gedcomArray, gedNameArray, yearFromArray, yearToArray, defaultGedcom) {

		controlDiv.setAttribute("id","wmMenu");
		controlDiv.setAttribute("class","headerEventMap");
		controlDiv.innerHTML = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;--------&nbsp;&nbsp;&nbsp;<b>'+
		                       textMessages['mapOptions'] + 
		                       '</b>&nbsp;&nbsp;&nbsp;--------';
		
		// parent0
		var controlParent0 = document.createElement('DIV');
		controlParent0.setAttribute("id","ScrollHeader0");
		controlParent0.setAttribute("class","parentEventMap");
		controlParent0.innerHTML = "&nbsp;<b>"+textMessages['gedcom']+"</b>: ";		
		var controlSelectTree = document.createElement('SELECT');
		controlSelectTree.setAttribute("id","wmGedcom");

		for (i = 0; i < gedcomArray.length; i++) {
			 var o = document.createElement('OPTION');
			 o.text = gedNameArray[i];
			 o.value = gedcomArray[i];
			 if (gedcomSelected == gedcomArray[i]) o.setAttribute("selected","selected");
			 controlSelectTree.appendChild(o);                
		}
		if (eventHandling == "1") {	//handling events, all filters are taken in account	
				//On changing the tree, the whole map is updated
				controlSelectTree.addEventListener('change', function(){
					markerClusterer = UpdateCluster(menuFiltersArray, map, controlSelectTree.options[controlSelectTree.selectedIndex].value, controlSelectDateFrom.options[controlSelectDateFrom.selectedIndex].value, controlSelectDateTo.options[controlSelectDateTo.selectedIndex].value, eventsStatisticsBool);
				});
		} else { // when events are not handled, just the tree changes
			//On changing the tree, the whole map is updated
			controlSelectTree.addEventListener('change', function(){
				markerClusterer = UpdateCluster(menuFiltersArray, map, controlSelectTree.options[controlSelectTree.selectedIndex].value, "----", "----", false);
			});
		}

		controlParent0.appendChild(controlSelectTree);		
		controlDiv.appendChild(controlParent0);

		if (eventHandling == "1") {	//from here to the end of function: execute when events are handled			
	        // parent1
	        var controlParent1 = document.createElement('DIV');
			controlParent1.setAttribute("id","ScrollHeader1");
			controlParent1.setAttribute("class","openEventMap");
			controlParent1.innerHTML = '<a href="#" title="">'+textMessages['eventType']+'</a>';
	
			var controlSubItems1 = document.createElement('DIV');
				controlSubItems1.setAttribute("id","ScrollItems1");
				controlSubItems1.setAttribute("class","subMenu1");
			var controlSub1_1 = document.createElement('DIV');
				controlSub1_1.setAttribute("id","ScrollItem1");
				controlSub1_1.setAttribute("class","subItemTrue");
				controlSub1_1.innerHTML = '<a href="#" title=""><img src="img/eventsMap_tng_cal_birth.png" />&nbsp;'+
				                           textMessages['birth']+
				                           '</a>';
				controlSub1_1.onclick = function() {
					menuFiltersArray[0] = (menuFiltersArray[0]) ? false : true;
					markerClusterer = UpdateCluster(menuFiltersArray, map, controlSelectTree.options[controlSelectTree.selectedIndex].value, controlSelectDateFrom.options[controlSelectDateFrom.selectedIndex].value, controlSelectDateTo.options[controlSelectDateTo.selectedIndex].value, eventsStatisticsBool);
					if (document.getElementById("ScrollItem1").getAttribute("class") == 'subItemTrue') 
					document.getElementById("ScrollItem1").setAttribute("class", "subItemFalse");
					else document.getElementById("ScrollItem1").setAttribute("class", "subItemTrue");				
				}
				controlSubItems1.appendChild(controlSub1_1);				
			var controlSub1_2 = document.createElement('DIV');
				controlSub1_2.setAttribute("id","ScrollItem2");
				controlSub1_2.setAttribute("class","subItemTrue");
				controlSub1_2.innerHTML = '<a href="#" title=""><img src="img/eventsMap_tng_cal_bapt.png" />&nbsp;'+
				                           textMessages['christened']+
				                           '</a>';
				controlSub1_2.onclick = function() {
					menuFiltersArray[1] = (menuFiltersArray[1]) ? false : true;
					markerClusterer = UpdateCluster(menuFiltersArray, map, controlSelectTree.options[controlSelectTree.selectedIndex].value, controlSelectDateFrom.options[controlSelectDateFrom.selectedIndex].value, controlSelectDateTo.options[controlSelectDateTo.selectedIndex].value, eventsStatisticsBool);
					if (document.getElementById("ScrollItem2").getAttribute("class") == 'subItemTrue') 
					document.getElementById("ScrollItem2").setAttribute("class", "subItemFalse");
					else document.getElementById("ScrollItem2").setAttribute("class", "subItemTrue");
				}
				controlSubItems1.appendChild(controlSub1_2);
			var controlSub1_3 = document.createElement('DIV');
				controlSub1_3.setAttribute("id","ScrollItem3");
				controlSub1_3.setAttribute("class","subItemTrue");
				controlSub1_3.innerHTML = '<a href="#" title=""><img src="img/eventsMap_tng_cal_marr.png" />&nbsp;'+
				                           textMessages['married']+
				                           '</a>';
				controlSub1_3.onclick = function() {
					menuFiltersArray[2] = (menuFiltersArray[2]) ? false : true;
					markerClusterer = UpdateCluster(menuFiltersArray, map, controlSelectTree.options[controlSelectTree.selectedIndex].value, controlSelectDateFrom.options[controlSelectDateFrom.selectedIndex].value, controlSelectDateTo.options[controlSelectDateTo.selectedIndex].value, eventsStatisticsBool);
					if (document.getElementById("ScrollItem3").getAttribute("class") == 'subItemTrue') 
					document.getElementById("ScrollItem3").setAttribute("class", "subItemFalse");
					else document.getElementById("ScrollItem3").setAttribute("class", "subItemTrue");
				}
				controlSubItems1.appendChild(controlSub1_3);
			var controlSub1_4 = document.createElement('DIV');
				controlSub1_4.setAttribute("id","ScrollItem4");
				controlSub1_4.setAttribute("class","subItemTrue");
				controlSub1_4.innerHTML = '<a href="#" title=""><img src="img/eventsMap_tng_cal_death.png" />&nbsp;'+
				                          textMessages['died']+
				                          '</a>';
				controlSub1_4.onclick = function() {
					menuFiltersArray[3] = (menuFiltersArray[3]) ? false : true;
					markerClusterer = UpdateCluster(menuFiltersArray, map, controlSelectTree.options[controlSelectTree.selectedIndex].value, controlSelectDateFrom.options[controlSelectDateFrom.selectedIndex].value, controlSelectDateTo.options[controlSelectDateTo.selectedIndex].value, eventsStatisticsBool);
					if (document.getElementById("ScrollItem4").getAttribute("class") == 'subItemTrue') 
					document.getElementById("ScrollItem4").setAttribute("class", "subItemFalse");
					else document.getElementById("ScrollItem4").setAttribute("class", "subItemTrue");
					
				}
				controlSubItems1.appendChild(controlSub1_4);
			var controlSub1_5 = document.createElement('DIV');
				controlSub1_5.setAttribute("id","ScrollItem5");
				controlSub1_5.setAttribute("class","subItemTrue");
				controlSub1_5.innerHTML = '<a href="#" title=""><img src="img/eventsMap_tng_cal_burial.png" />&nbsp;'+
	                                      textMessages['buried']+
	                                      '</a>';
				controlSub1_5.onclick = function() {
					menuFiltersArray[4] = (menuFiltersArray[4]) ? false : true;
					markerClusterer = UpdateCluster(menuFiltersArray, map, controlSelectTree.options[controlSelectTree.selectedIndex].value, controlSelectDateFrom.options[controlSelectDateFrom.selectedIndex].value, controlSelectDateTo.options[controlSelectDateTo.selectedIndex].value, eventsStatisticsBool);
					if (document.getElementById("ScrollItem5").getAttribute("class") == 'subItemTrue') 
					document.getElementById("ScrollItem5").setAttribute("class", "subItemFalse");
					else document.getElementById("ScrollItem5").setAttribute("class", "subItemTrue");
				}
				controlSubItems1.appendChild(controlSub1_5);
			var controlSub1_6 = document.createElement('DIV');
				controlSub1_6.setAttribute("id","ScrollItem6");
				controlSub1_6.setAttribute("class","subItemTrue");
				controlSub1_6.innerHTML = '<a href="#" title="">&omicron;&nbsp;&nbsp;'+
			                              textMessages['otherEvent']+
			                              '</a>';
				controlSub1_6.onclick = function() {
					menuFiltersArray[5] = (menuFiltersArray[5]) ? false : true;
					markerClusterer = UpdateCluster(menuFiltersArray, map, controlSelectTree.options[controlSelectTree.selectedIndex].value, controlSelectDateFrom.options[controlSelectDateFrom.selectedIndex].value, controlSelectDateTo.options[controlSelectDateTo.selectedIndex].value, eventsStatisticsBool);
					if (document.getElementById("ScrollItem6").getAttribute("class") == 'subItemTrue') 
					document.getElementById("ScrollItem6").setAttribute("class", "subItemFalse");
					else document.getElementById("ScrollItem6").setAttribute("class", "subItemTrue");
				}
				controlSubItems1.appendChild(controlSub1_6);
				
	        controlParent1.addEventListener('click', function(){
				$("#ScrollItems1").slideToggle("fast", function() {
			  if (document.getElementById("ScrollHeader1").getAttribute("class") == "parentEventMap") 
				document.getElementById("ScrollHeader1").setAttribute("class", "openEventMap");
			  else document.getElementById("ScrollHeader1").setAttribute("class", "parentEventMap");
				});
			});
	        controlDiv.appendChild(controlParent1);
			controlDiv.appendChild(controlSubItems1);
	        
			// parent2
	        var controlParent2 = document.createElement('DIV');
			controlParent2.setAttribute("id","ScrollHeader2");
			controlParent2.setAttribute("class","openEventMap");
			controlParent2.innerHTML = '<a href="#" title="">'+textMessages['dateRange']+'</a>';
			
			var controlSubItems2 = document.createElement('DIV');
				controlSubItems2.setAttribute("id","ScrollItems2");
				controlSubItems2.setAttribute("class","subMenu2");
			var controlSelectDateFrom = document.createElement('SELECT');
				controlSelectDateFrom.setAttribute("id","dataFrom");
				for (i = 0; i < yearFromArray.length; i++) {
				 var o = document.createElement('OPTION');
				 o.text = o.value = yearFromArray[i];
				 controlSelectDateFrom.appendChild(o);                
				}
				controlSelectDateFrom.value=yearFromArray[0]; //let it be initialized on first value
				//On changing the date range, the whole map is updated
				controlSelectDateFrom.addEventListener('change', function(){
				markerClusterer = UpdateCluster(menuFiltersArray, map, controlSelectTree.options[controlSelectTree.selectedIndex].value, controlSelectDateFrom.options[controlSelectDateFrom.selectedIndex].value, controlSelectDateTo.options[controlSelectDateTo.selectedIndex].value, eventsStatisticsBool);
				});
				controlSubItems2.appendChild(controlSelectDateFrom);	
			var controlSelectDateTo = document.createElement('SELECT');
				controlSelectDateTo.setAttribute("id","dataFrom");
				for (i = 0; i < yearToArray.length; i++) {
				 var o = document.createElement('OPTION');
				 o.text = o.value = yearToArray[i];
				 controlSelectDateTo.appendChild(o);                
				}
				controlSelectDateTo.value=yearToArray[yearToArray.length-1]; //let it be initialized on last value
				//On changing the date range, the whole map is updated
				controlSelectDateTo.addEventListener('change', function(){
				markerClusterer = UpdateCluster(menuFiltersArray, map, controlSelectTree.options[controlSelectTree.selectedIndex].value, controlSelectDateFrom.options[controlSelectDateFrom.selectedIndex].value, controlSelectDateTo.options[controlSelectDateTo.selectedIndex].value, eventsStatisticsBool);
				});
				controlSubItems2.appendChild(controlSelectDateTo);	
				
			controlParent2.addEventListener('click', function(){
				$("#ScrollItems2").slideToggle("fast", function() {
			  if (document.getElementById("ScrollHeader2").getAttribute("class") == "parentEventMap") 
				document.getElementById("ScrollHeader2").setAttribute("class", "openEventMap");
			  else document.getElementById("ScrollHeader2").setAttribute("class", "parentEventMap");
				});
			});
	        controlDiv.appendChild(controlParent2);
			controlDiv.appendChild(controlSubItems2);
			
			
	        // parent3
	        var controlParent3 = document.createElement('DIV');
			controlParent3.setAttribute("id","ScrollHeader3");
			controlParent3.setAttribute("class","parentEventMap");
	
			var controlParent3Statistics = document.createElement('button');
			controlParent3Statistics.setAttribute("id","refresh");
			controlParent3Statistics.innerHTML = textMessages['showStatistics'];
			//If user toggled statistics, display totals DIV and change boolean
			google.maps.event.addDomListener(controlParent3Statistics, 'click', function() {
			$("#ScrollItems4").slideToggle("fast", function() {
				  if (document.getElementById("ScrollHeader4").getAttribute("class") == "parentEventMap"){ 
					document.getElementById("ScrollHeader4").setAttribute("class", "openEventMap");
					eventsStatisticsBool=true;
					markerClusterer = UpdateCluster(menuFiltersArray, map, controlSelectTree.options[controlSelectTree.selectedIndex].value, controlSelectDateFrom.options[controlSelectDateFrom.selectedIndex].value, controlSelectDateTo.options[controlSelectDateTo.selectedIndex].value, eventsStatisticsBool);
					}
				  else {
					document.getElementById("ScrollHeader4").setAttribute("class", "parentEventMap");
					eventsStatisticsBool=false;
					markerClusterer = UpdateCluster(menuFiltersArray, map, controlSelectTree.options[controlSelectTree.selectedIndex].value, controlSelectDateFrom.options[controlSelectDateFrom.selectedIndex].value, controlSelectDateTo.options[controlSelectDateTo.selectedIndex].value, eventsStatisticsBool);
					}
				});		
			});
			controlParent3.appendChild(controlParent3Statistics);
			
			var controlParent3Clear = document.createElement('button');
			controlParent3Clear.setAttribute("id","clear");
			controlParent3Clear.innerHTML = textMessages['clearMap'];
			google.maps.event.addDomListener(controlParent3Clear, 'click', function() {
			    if (markerClusterer) {
					eventsStatisticsBool=false;
	                menuFiltersArray = new Array(true,true,true,true,true, true);
	                CustomControllers(controlDiv, map, gedcomArray, gedNameArray, yearFromArray, yearToArray, "------");
					markerClusterer = UpdateCluster(menuFiltersArray, map, gedcomSelected, "----", "----", false);
	        	}
				// *** STATISTICS
				updateStatistics(0,0,eventsStatisticsBool,0,0,0,0,0,0);
			});
			controlParent3.appendChild(controlParent3Clear);
			controlDiv.appendChild(controlParent3);		
					
					
			// parent4
	        var controlParent4 = document.createElement('DIV');
			controlParent4.setAttribute("id","ScrollHeader4");
			controlParent4.setAttribute("class","parentEventMap");
			// controlParent4.innerHTML = '<a href="#" title="">-</a>';
		
			var controlSubItems4 = document.createElement('DIV');
			controlSubItems4.setAttribute("id","ScrollItems4");
			controlSubItems4.setAttribute("class","subMenu4");
				
			var controlTotalEvents = document.createElement('DIV');
			controlTotalEvents.setAttribute("id","DivTotalEvents");
			controlTotalEvents.innerHTML = 'Total Events: 0';
			controlSubItems4.appendChild(controlTotalEvents);
			
			var controlTotalPlaces = document.createElement('DIV');
			controlTotalPlaces.setAttribute("id","DivTotalPlaces");
			controlTotalPlaces.innerHTML = 'Total Places: 0';
			controlSubItems4.appendChild(controlTotalPlaces);
			
			controlDiv.appendChild(controlParent4);
			controlDiv.appendChild(controlSubItems4);
						
		}				
				
		
	} //end of function
